<?php

/**
 * JOOk2Metas plugin
 * PHP 5.0
 * 
 * @name        
 * @version     1.0.0.0
 * @since       1.0.0.0
 * @copyright	Copyright (C) 2011 - 2012 JOOservices Ltd Company. All rights reserved.
 * @license	JOOservices Ltd Company
 * @link        http://jooservices.com 
 */
/* no direct access */
defined('_JEXEC') or die;
?>
<?php

if (!class_exists('jooK2metasModel')) {
    jimport('joomla.application.component.model');
    JTable::addIncludePath(JPATH_COMPONENT . DS . 'tables');

    /**
     * K2metas Model
     */
    class jooK2metasModel {

        private $_item;

        /**
         * Construct method
         * @param type $item 
         */
        public function __construct($item) {
            $this->_item = $item;
        }

        /**
         * Method to get array tags of current item
         * @return array 
         */
        private function _getTags() {
            $query = ' SELECT tr.id, tr.itemID, tr.tagId, t.name '
                    . ' FROM joox_k2_tags_xref AS tr '
                    . ' INNER JOIN joox_k2_tags AS t ON t.id = tr.tagID '
                    . ' WHERE t.published = 1 '
                    . ' AND tr.itemID = ' . (int) $this->_item->id;

            // Get a database object
            $db = & JFactory::getDBO();
            $db->setQuery($query);
            return $db->loadAssocList();
        }

        /**
         * Method to get array keys of current item
         * @return type 
         */
        private function _getMetakeys() {
            return explode(',', $this->_item->metakey);
        }

        public function parseMetaKeys($format) {
            /* get exists keys */
            $keys = $this->_getMetakeys();
            if (!is_array($keys))
                $keys = array();
            $tags = $this->_getTags();

            $newKeys['standard'] = array();
            $newKeys['upper'] = array();
            $newKeys['lower'] = array();
            foreach ($tags as $tag) { /* loop tag to make an formatted array */
                if (!in_array($tag['name'], $keys)) {
                    $newKeys['standard'][] = $tag['name'];
                }
                if (!in_array(strtoupper($tag['name']), $keys)) {
                    $newKeys['upper'][] = strtoupper($tag['name']);
                }
                if (!in_array(strtolower($tag['name']), $keys)) {
                    $newKeys['lower'][] = strtolower($tag['name']);
                }
                /* @todo UTF here */
            }
            $metaKeys = $format;
            $metaKeys = str_replace('{standard_tag}', implode(',', $newKeys['standard']), $metaKeys);
            $metaKeys = str_replace('{upper_tag}', implode(',', $newKeys['upper']), $metaKeys);
            $metaKeys = str_replace('{lower_tag}', implode(',', $newKeys['lower']), $metaKeys);

            $metaKeys = explode(',', $metaKeys);
            $metaKeys = trim(str_replace(',,', '', implode(',', array_merge($metaKeys, $keys))), ',');
            return $metaKeys;
        }

        /**
         * Method to update item title into meta description
         * @param type $format 
         */
        public function parseMetaDescription($format) {
            /**
             * @uses
             * This method only call for new item 
             */
            $metaDescription = $format;
            $metaDescription = str_replace('{standard_title}', $this->_item->title, $metaDescription);
            $metaDescription = str_replace('{upper_title}', strtoupper($this->_item->title), $metaDescription);
            $metaDescription = str_replace('{lower_title}', strtolower($this->_item->title), $metaDescription);
            $metaDescription = str_replace('{utf_title}', JApplication::stringURLSafe($this->_item->title), $metaDescription);
            return $metaDescription;
        }

        /**
         * @uses
         * Right now desc only work for new item and do not allow custom input while saving 
         * @param type $descFormat 
         */
        public function updateMetaDesc($descFormat = '{standard_title},{upper_title},{lower_title},{utf_title}') {
            $row = &JTable::getInstance('K2Item', 'Table');
            $row->load($this->_item->id);
            $row->metadesc = $this->parseMetaDescription($descFormat);
            $row->check();
            $row->store();
        }

        public function updateMetaKey($keyFormat = '{standard_tag},{upper_tag},{lower_tag}') {
            $row = &JTable::getInstance('K2Item', 'Table');
            $row->load($this->_item->id);
            $row->metakey = $this->parseMetaKeys($keyFormat);
            $row->check();
            return $row->store();
        }

    }

}
?>